<template>
    <div class="monitor-dialog">
        <!-- 设备信息 预警信息 点位视频 -->
        <div class="btn-content">
            <div
                class="btn"
                :class="activeName === '设备信息' ? 'btn-active' : ''"
                @click="changeTab('设备信息')"
            >
                设备信息
            </div>
            <div
                class="btn"
                :class="activeName === '预警信息' ? 'btn-active' : ''"
                @click="changeTab('预警信息')"
            >
                预警信息
            </div>
            <!-- <div
                class="btn"
                :class="activeName === '点位视频' ? 'btn-active' : ''"
                @click="changeTab('点位视频')"
            >
                点位视频
            </div> -->
        </div>
        <!-- 设备信息 -->
        <div class="device-info" v-if="activeName === '设备信息'">
            <div class="device-item">
                <div class="label">设备编码：</div>
                <div class="value">{{ monitorInfo.code }}</div>
            </div>
            <div class="device-item">
                <div class="label">设备名称：</div>
                <div class="value">{{ monitorInfo.name }}</div>
            </div>
            <div class="device-item">
                <div class="label">经度：</div>
                <div class="value">{{ monitorInfo.lgtd }}</div>
            </div>
            <div class="device-item">
                <div class="label">纬度：</div>
                <div class="value">{{ monitorInfo.lttd }}</div>
            </div>
            <div class="popup-monitor-video">
                <player ref="player" />
            </div>
        </div>
        <!-- 预警信息 -->
        <div class="warning-item" v-if="activeName === '预警信息'">
            <div class="table-info">
                <div class="header">
                    <div class="header-item" style="width: 7%">序号</div>
                    <div class="header-item" style="width: 20%">事件名称</div>
                    <div class="header-item" style="width: 15%">事件状态</div>
                    <div class="header-item" style="width: 30%">发生日期</div>
                    <div class="header-item" style="width: 13%">预警图片</div>
                    <div class="header-item" style="width: 15%">操作</div>
                </div>
                <div class="body-content">
                    <div
                        class="body"
                        v-for="(item, index) in tableData"
                        :key="index"
                    >
                        <div class="body-item" style="width: 7%">
                            {{
                                index +
                                (pageParams.page - 1) * pageParams.pageSize +
                                1
                            }}
                        </div>
                        <div class="body-item" style="width: 20%">
                            {{ item.eventName }}
                        </div>
                        <div class="body-item" style="width: 15%">
                            <!-- {{ getDictName('sjzt', item.eventStatus) }} -->
                            <!-- <el-tag
                                    size="mini"
                                    type="info"
                                    effect="dark"
                                    >未处置</el-tag
                                > -->
                                未处置
                        </div>
                        <div class="body-item" style="width: 30%">
                            {{ item.eventProduceTime }}
                        </div>
                        <div class="body-item operate" style="width: 13%">
                            <el-tag
                                size="mini"
                                @click="openImg(item)"
                                type="warning"
                                effect="dark"
                                >查看</el-tag
                            >
                        </div>
                        <div class="body-item operate" style="width: 15%">
                            <el-tag size="mini" @click="goSystem(item)" effect="dark"
                                >处理</el-tag
                            >
                        </div>
                    </div>
                </div>
                <el-pagination
                    style="float: right; margin-top: 6px"
                    :current-page="pageParams.page"
                    :page-size="pageParams.pageSize"
                    @current-change="handleCurrentChange"
                    layout="total, prev, pager, next, jumper"
                    :total="total"
                >
                </el-pagination>
            </div>
            <el-image
                ref="warningImg"
                style="width: 100px; height: 100px"
                :src="url"
                :preview-src-list="srcList"
                v-show="false"
            >
            </el-image>
        </div>
        <!-- 点位视频 -->
        <!-- <div class="video-item" v-if="activeName === '点位视频'">
            <div class="popup-monitor-address">
                地址：<span
                    v-if="monitorInfo.areaFullName && monitorInfo.detailAddress"
                    >{{
                        monitorInfo.areaFullName.replaceAll('/', '') +
                        monitorInfo.detailAddress
                    }}</span
                >
            </div>
        </div> -->
    </div>
</template>

<script>
import player from '../player.vue'
import bigScreenAPI from '@/api/BigScreen/index.js'
import utils from '@/utils.js'
export default {
    name: 'monitorDialog',
    components: {
        player,
    },
    props: {
        monitorInfo: {
            type: Object,
            default: () => {
                return {}
            },
        },
    },
    watch: {
        activeName: {
            handler(newVal, oldVal) {
                if (newVal === '设备信息') {
                    setTimeout(() => {
                        this.$refs.player.getUrlAndPlay(this.monitorInfo)
                    }, 100)
                }
                if (newVal === '预警信息') {
                    setTimeout(() => {
                        this.getWarningList()
                    }, 100)
                }
            },
            immediate: true,
        },
    },
    data() {
        return {
            activeName: '设备信息', // tab激活项
            tableData: [], // 预警数据
            workPlatMenu: [], // 菜单信息
            url: '',
            srcList: [],
            pageParams: {
                page: 1,
                pageSize: 10,
            }, // 分页参数
            total: 0, // 总数
        }
    },
    created() {},
    mounted() {
        this.$store.dispatch('menu/actionFrontMenus').then((data) => {
            this.workPlatMenu = data.filter((item) => item.alias === 'normal')
        })
    },
    methods: {
        // 切换tab项
        changeTab(item) {
            this.activeName = item
        },
        // 获取预警信息
        getWarningList() {
            bigScreenAPI
                .queryWarningListByCode({
                    groupRelation: 'AND',
                    groupTree: {},
                    pageBean: {
                        showTotal: true,
                        ...this.pageParams
                    },
                    params: {},
                    querys: [
                        {
                            group: 'main',
                            operation: 'EQUAL',
                            parentGroup: '',
                            property: 'device_code_',
                            relation: 'AND',
                            value: this.monitorInfo.code,
                        },
                    ],
                })
                .then((res) => {
                    console.log(res)
                    this.tableData = res.rows
                    this.total = res.total
                })
        },
        // 跳转后台
        goSystem(item) {
            // this.$router.push({path: `/platLayout/${this.workPlatMenu[0].children[0].children[1].alias}`,})
            // this.$router.push({path: `/platLayout/BlacklistManage`})
            this.$emit('eventConfirmation',item,'监控设备')
        },
        // 获取字典值翻译
        getDictName(code, value) {
            return utils.getDictName(code, value)
        },
        // 打开预警图片
        openImg(item) {
            // console.log(this.$refs.warningImg);
            if (item.imgUrl) {
                bigScreenAPI.getImgByUrl(item.imgUrl).then((res) => {
                    this.srcList = res
                    this.$refs.warningImg.clickHandler()
                })
            } else {
                this.$message({
                    message: '暂无图片！',
                    type: 'warning',
                })
            }
        },
        // 翻页
        handleCurrentChange(val) {
            this.pageParams.page = val
            this.getWarningList()
        },
    },
}
</script>

<style scoped lang="scss">
.monitor-dialog {
}
.btn-content {
    display: flex;
    justify-content: center;
    align-items: center;
    .btn {
        width: 120px;
        height: 30px;
        border: 1px solid #2cdfe8;
        display: flex;
        justify-content: center;
        align-items: center;
        color: #fff;
        cursor: pointer;
    }
    .btn-active {
        background-color: #385aff;
    }
}
.popup-monitor-address {
    font-size: 14px;
    color: #ffffff;
    font-weight: 700;
}
.popup-monitor-video {
    width: 100%;
    height: 337px;
    background-color: #0e2039;
    margin-top: 10px;
}
.warning-item {
    padding: 15px 0 0 0;
    height: 370px;
    .table-info {
        border: 1px solid #42bddc;
        .header {
            display: flex;
            height: 35px;
            background: linear-gradient(
                360deg,
                #1a355c 0%,
                rgba(66, 93, 133, 0.09) 100%
            );
            .header-item {
                color: #fff;
                display: flex;
                align-items: center;
                justify-content: center;
                padding: 0 0 0 6px;
                font-size: 16px;
            }
        }
        .body-content {
            height: 305px;
            overflow-y: auto;
            .body {
                display: flex;
                // height: 25px;
                border-right: none;
                border: 2px solid transparent;
                padding: 3px 0;

                &:hover {
                    background: linear-gradient(
                        90deg,
                        rgba(16, 40, 73, 0) 0%,
                        #102849 51%,
                        rgba(16, 40, 73, 0) 100%
                    );
                    border-radius: 0px 0px 0px 0px;
                    border: 2px solid;
                    border-image: linear-gradient(
                            90deg,
                            rgba(255, 255, 255, 0),
                            rgba(93, 144, 194, 1),
                            rgba(93, 144, 194, 0)
                        )
                        2 2;
                }
                .body-item {
                    color: #eee;
                    display: flex;
                    align-items: center;
                    justify-content: center;
                    padding: 0 0 0 6px;
                }
                .operate {
                    span {
                        cursor: pointer;
                        // &:hover {
                        //     color: #1a8cff;
                        // }
                    }
                }
            }
        }
    }
}
.device-info {
    height: 400px;
    padding: 15px 0 0 0;
    display: flex;
    flex-wrap: wrap;
    align-content: flex-start;
    .device-item {
        width: 50%;
        margin: 10px 0 0 0;
        display: flex;
        .label {
            color: #2ca6ff;
        }
        .value {
            color: #fff;
        }
    }
}
</style>
